# Utility IO & Telegraphs

## Functions
DLLEXPORT TECELLA_ERRNUM CALL | tecella_utility_dac_set (TECELLA_HNDL h, double value, int index=0)
DLLEXPORT TECELLA_ERRNUM CALL | tecella_utility_trigger_out (TECELLA_HNDL h, int index)
DLLEXPORT TECELLA_ERRNUM CALL | tecella_utility_set_stimulus (TECELLA_HNDL h, int channel, int stimulus_index)
DLLEXPORT TECELLA_ERRNUM CALL | tecella_telegraph_enable (TECELLA_HNDL h, bool enable)

## Detailed Description

Various functions for controling utility DACs and digital IOs. Useful for controlling external devices via the amplifier.

## Function Documentation

DLLEXPORT TECELLA_ERRNUM CALL tecella_telegraph_enable | ( | TECELLA_HNDL | h,
|  | bool | enable |
| ) |  |  |

Enables or disables the telegraph outputs of the amplifier.

Telegraphs are output voltages from an amplifier to a digitizer that tell the digitizer and acquisition software the current gain selected and the cuttoff frequency of the low pass filter. This helps the acquisition software know what sampling rates are good and how to scale the amplified signal to the proper units.

The telegraph feature is only useful when the amplifier is connected to an external digitizer instead of using the digitizer that comes integrated with the amplifier.

Very few amplifiers support telegraphs, such as some models of the Pico. To see if an amplifier supports telegraphs, check the TECELLA_HW_PROPS_EX_01.supports_telegraphs field.

When telegraphs are enabled, some of the utility dacs and digital IO's will come under the control of the amplifier and cannot be used by the user for other puposes. Refer to the amplifier's documentation to see which utility IO's are used for telegraphs.

Parameters:

  | h | A handle to an initialized device.
  | enable | If true, enables telegraph outputs. If false, disables telegraphs and frees utility IO's for use.

DLLEXPORT TECELLA_ERRNUM CALL tecella_utility_dac_set | ( | TECELLA_HNDL | h,
|  | double | value,
|  | int | index = `0` |
| ) |  |  |

Sets the utility DAC voltage.

DLLEXPORT TECELLA_ERRNUM CALL tecella_utility_set_stimulus | ( | TECELLA_HNDL | h,
|  | int | channel,
|  | int | stimulus_index |
| ) |  |  |

Sets the stimulus index for stimulus-only outputs. Currently, only supported by Richmond amplifiers.

DLLEXPORT TECELLA_ERRNUM CALL tecella_utility_trigger_out | ( | TECELLA_HNDL | h,
|  | int | index |
| ) |  |  |

Sets the utility trigger out.